%% CLRM Approach 
% This section determines the optimal decision policy based on CLRM approach
% To run this algorithm, sections 1, 2, 3, and 4 from Modified_LSM_Algorithm.m has to be run first

N_MC = size(ObsRate_Phase1n2_real_time_ShiftTime,1);
FieldLifeTime = size(ObsRate_Phase1n2_real_time_ShiftTime,2);
N_Phase1n2LifeTime = sum(1:FieldLifeTime+1);
N_LifeTimeComb = N_Phase1n2LifeTime;
Times = 1:1:FieldLifeTime;
CLRM_OptNPV_real = zeros(N_MC,1);
NPV_Tab_matrix = transpose(NPVmatrix_reals);
Prior_ENPV = meanNPVvector(:,3);
[max_Prior_ENPV, max_Prior_ENPV_idx] = max(meanNPVvector(:,3),[],1);
x_data_switch_CLRM = ObsRate_Phase1n2_real_time_ShiftTime(:,:,FieldLifeTime+1);

CLRM_PhaseLifes_Opt_reals = zeros(N_MC,2);

if max_Prior_ENPV_idx <= Times(FieldLifeTime)+1 %Finding if Switch Time is optimal at Y1
    Shift_time = 1;
    t_dataPhase2 = 1;
    while t_dataPhase2 <= Times(FieldLifeTime-Shift_time+1) 
        if t_dataPhase2 == 1 && max_Prior_ENPV_idx == 1 %Switch and Stop at Y1 are optimal
            for i_MC = 1: N_MC
                CLRM_OptNPV_real(i_MC,1) = max_Prior_ENPV; 
            end    
            break; %The whole loop will break here 
        else %Given Switch at Y1 and Stop is not at Y1
            x_data_stop_CLRM = ObsRate_Phase1n2_real_time_ShiftTime(:,:,Shift_time);
            X_stop_CLRM = [ones(N_MC,1) x_data_stop_CLRM(:,1:t_dataPhase2)]; 
            y_data_stop_CLRM = NPV_Tab_matrix(:,t_dataPhase2+1:FieldLifeTime+1); 
            y_reg_stop_CLRM = zeros(N_MC,FieldLifeTime-t_dataPhase2+1);
            for t = 1: FieldLifeTime-t_dataPhase2+1
                y_reg_stop_CLRM(:,t) = X_stop_CLRM*regress(y_data_stop_CLRM(:,t),X_stop_CLRM); 
            end
            [StopTime_reg,StopTime_idx] = max(y_reg_stop_CLRM,[],2); 
        for i_MC = 1: N_MC
            if StopTime_reg(i_MC) == y_reg_stop_CLRM(i_MC,1) && CLRM_OptNPV_real(i_MC,1) == 0
                CLRM_OptNPV_real(i_MC,1) = y_data_stop_CLRM(i_MC,1);
                CLRM_PhaseLifes_Opt_reals(i_MC,1) = Shift_time-1; 
                CLRM_PhaseLifes_Opt_reals(i_MC,2) = t_dataPhase2+StopTime_idx(i_MC)-1; 
            else
                continue;
            end 
        end
        end
        t_dataPhase2 = t_dataPhase2+1;
    end
else
% This part is to find the corresponding optimal stop time given Switch time is not at Y1
    for Shift_time = 2: FieldLifeTime %Finding and recording the optimal switch time before determining the stop time
        N_LifeTimeComb = N_LifeTimeComb-Times(FieldLifeTime-Shift_time+2)-1;
        y_data_switch_CLRM = NPV_Tab_matrix(:,N_Phase1n2LifeTime-N_LifeTimeComb+1:N_Phase1n2LifeTime);
        y_reg_switch_CLRM = zeros(N_MC,N_LifeTimeComb);
        ENPVTabComp = zeros(N_MC,N_LifeTimeComb);
        X_switch_CLRM = [ones(N_MC,1) x_data_switch_CLRM(:,1:Shift_time-1)];
        for i_LifeTimeComb = 1: N_LifeTimeComb 
            coef_reg_CLRM = regress(y_data_switch_CLRM(:,i_LifeTimeComb),X_switch_CLRM);
            y_reg_switch_CLRM(:,i_LifeTimeComb) = X_switch_CLRM*coef_reg_CLRM;
            ENPVTabComp(:,i_LifeTimeComb) = y_reg_switch_CLRM(:,i_LifeTimeComb);
        end
   
    [CLRM_reg,CLRM_idx] = max(ENPVTabComp,[],2);
    
    if Shift_time == FieldLifeTime
        [SwitchDecision_CLRM,SwitchDecision_CLRM_idx] = find(CLRM_idx <= Times(FieldLifeTime-Shift_time+2)+1);
        [ContinueTime_reg,ContinueTime_idx] = find(CLRM_idx == Times(FieldLifeTime-Shift_time+2)+1);
        for i_path = 1: length(ContinueTime_reg) 
            if CLRM_OptNPV_real(ContinueTime_reg(i_path),1) == 0
               CLRM_OptNPV_real(ContinueTime_reg(i_path),1) = y_data_switch_CLRM(ContinueTime_reg(i_path),end);
               CLRM_PhaseLifes_Opt_reals(ContinueTime_reg(i_path),1) = FieldLifeTime; 
               CLRM_PhaseLifes_Opt_reals(ContinueTime_reg(i_path),2) = 0; 
            else
                continue;
            end 
        end
    else
        [SwitchDecision_CLRM,SwitchDecision_CLRM_idx] = find(CLRM_idx <= Times(FieldLifeTime-Shift_time+2)); 
    end
    
    x_data_stop_CLRM = ObsRate_Phase1n2_real_time_ShiftTime(:,:,Shift_time);    
    t_dataPhase2 = 1; 
    while t_dataPhase2 <= Times(FieldLifeTime-Shift_time+1)+1  	
        X_stop_CLRM = [ones(N_MC,1) x_data_stop_CLRM(:,1:t_dataPhase2+Shift_time-2)]; 
        y_data_stop_CLRM = y_data_switch_CLRM(:, t_dataPhase2:Times(FieldLifeTime-Shift_time+1)+1);  
        y_reg_stop_CLRM = zeros(N_MC,Times(FieldLifeTime-Shift_time+1)-t_dataPhase2+2); 
        for t = 1: Times(FieldLifeTime-Shift_time+1)-t_dataPhase2+2 
            y_reg_stop_CLRM(:,t) = X_stop_CLRM*regress(y_data_stop_CLRM(:,t),X_stop_CLRM); 
        end
            [StopTime_reg,StopTime_idx] = max(y_reg_stop_CLRM,[],2); 
        for i_path = 1: length(SwitchDecision_CLRM) 
            if StopTime_reg(SwitchDecision_CLRM(i_path)) == y_reg_stop_CLRM(SwitchDecision_CLRM(i_path),1) && CLRM_OptNPV_real(SwitchDecision_CLRM(i_path),1) == 0
                CLRM_OptNPV_real(SwitchDecision_CLRM(i_path),1) = y_data_stop_CLRM(SwitchDecision_CLRM(i_path),1);
                CLRM_PhaseLifes_Opt_reals(SwitchDecision_CLRM(i_path),1) = Shift_time-1; 
                CLRM_PhaseLifes_Opt_reals(SwitchDecision_CLRM(i_path),2) = t_dataPhase2+StopTime_idx(SwitchDecision_CLRM(i_path))-2; 
            else
                continue;
            end 
        end
            t_dataPhase2 = t_dataPhase2+1;
    end
    end
end

DWI_CLRM_Phase1LifeTime = CLRM_PhaseLifes_Opt_reals(:,1);
DWI_CLRM_Phase2LifeTime = CLRM_PhaseLifes_Opt_reals(:,2);
DWI_CLRM_LifeTime = DWI_CLRM_Phase1LifeTime + DWI_CLRM_Phase2LifeTime;

EVWI_CLRM = mean(CLRM_OptNPV_real);
VOI_CLRM = EVWI_CLRM-EVWOI;
