%% Regression Function with dependency terms
%  This code consists of the modified version of the Sections 5 and 6 of Modified_LSM_Algorithm.m and CLRM.m
%  Thus, Sections 1 to 4 of Modified_LSM_Algorithm.m has to be run first before executing this code
%  This code corresponds to the Regression Function of Equation 17 in the report 

% 1. Path Table Generation

N_MC = size(ObsRate_Phase1n2_real_time_ShiftTime,1);
FieldLifeTime = size(ObsRate_Phase1n2_real_time_ShiftTime,2);
SRDM_Shift_Stop_OptNPV_real = zeros(N_MC,1);
        
PathTable = zeros(N_MC,FieldLifeTime+1);
PathTable(:,end) = NPVtable_LTPhase1_LTPhase2_real(FieldLifeTime+1,1,:);
Phase2_StopTime_real_Phase1LifeTime = zeros(N_MC,FieldLifeTime+1);

for k_Shift_time = 1: FieldLifeTime
        NPV_2Phases_matrix = zeros(N_MC,k_Shift_time+1); 
    for k_Stop_time = 1: k_Shift_time+1          
        NPV_2Phases_matrix(:,k_Stop_time) = NPVtable_LTPhase1_LTPhase2_real(FieldLifeTime-k_Shift_time+1,k_Stop_time,:);
    end
    for k_StopTime = 1: k_Shift_time    
        if k_StopTime == 1 
            x_data_stop_SRDM = ObsRate_Phase1n2_real_time_ShiftTime(:,1:FieldLifeTime-k_StopTime,FieldLifeTime-k_Shift_time+1); 
            x_data_cube_stop_SRDM = x_data_stop_SRDM(:,1:FieldLifeTime-k_StopTime-2).*x_data_stop_SRDM(:,2:FieldLifeTime-k_StopTime-1).*x_data_stop_SRDM(:,3:FieldLifeTime-k_StopTime); 
            X_stop_SRDM = [ones(N_MC,1) x_data_stop_SRDM x_data_cube_stop_SRDM]; 
            y_data_stop_matrix = [NPV_2Phases_matrix(:,k_Shift_time-k_StopTime+1) NPV_2Phases_matrix(:,k_Shift_time-k_StopTime+2)];
            [Stop_value,Stop_idx] = max([X_stop_SRDM*regress(NPV_2Phases_matrix(:,k_Shift_time-k_StopTime+1),X_stop_SRDM) X_stop_SRDM*regress(NPV_2Phases_matrix(:,k_Shift_time-k_StopTime+2),X_stop_SRDM)],[],2);
            for i_MC = 1: N_MC
                SRDM_Shift_Stop_OptNPV_real(i_MC,1) = y_data_stop_matrix(i_MC,Stop_idx(i_MC));
            end    
        else
            x_data_stop_SRDM = ObsRate_Phase1n2_real_time_ShiftTime(:,1:FieldLifeTime-k_StopTime,FieldLifeTime-k_Shift_time+1); 
            x_data_cube_stop_SRDM = x_data_stop_SRDM(:,1:FieldLifeTime-k_StopTime-2).*x_data_stop_SRDM(:,2:FieldLifeTime-k_StopTime-1).*x_data_stop_SRDM(:,3:FieldLifeTime-k_StopTime); 
            X_stop_SRDM = [ones(N_MC,1) x_data_stop_SRDM x_data_cube_stop_SRDM];
            y_data_stop_matrix = [NPV_2Phases_matrix(:,k_Shift_time-k_StopTime+1) SRDM_Shift_Stop_OptNPV_real(:,1)];
            [Stop_value,Stop_idx] = max([X_stop_SRDM*regress(NPV_2Phases_matrix(:,k_Shift_time-k_StopTime+1),X_stop_SRDM) X_stop_SRDM*regress(SRDM_Shift_Stop_OptNPV_real(:,1),X_stop_SRDM)],[],2);
            for i_MC = 1: N_MC
                SRDM_Shift_Stop_OptNPV_real(i_MC,1) = y_data_stop_matrix(i_MC,Stop_idx(i_MC));
            end  
        end
    end     
    for i_MC = 1: N_MC
        PathTable(i_MC,FieldLifeTime-k_Shift_time+1) = SRDM_Shift_Stop_OptNPV_real(i_MC,1);
        for k_Stop_time = 1: k_Shift_time+1
            if SRDM_Shift_Stop_OptNPV_real(i_MC,1) == NPV_2Phases_matrix(i_MC,k_Stop_time)
                Phase2_StopTime_real_Phase1LifeTime(i_MC,FieldLifeTime-k_Shift_time+1) = k_Stop_time-1;
            end
        end
    end  
end

% 2. SRDM Approach

FieldLifeTime = size(ObsRate_Phase1n2_real_time_ShiftTime,2);
y_data_continuation = zeros(N_MC,1);
y_data_shift = zeros(N_MC,1);
y_reg_continuation = zeros(N_MC,1);
y_reg_shift = zeros(N_MC,1);
x_data = ObsRate_Phase1n2_real_time_ShiftTime(:,:,FieldLifeTime+1);

ValueTable = zeros(N_MC,FieldLifeTime+1);
ValueTable(:,end) = PathTable(:,end);
SRDM_DecisionTable = zeros(N_MC,FieldLifeTime+1);
SRDM_DecisionTable(:,end) = 1;

for k_Shift_time = 1:FieldLifeTime
    x_data_cube = x_data(:,1:FieldLifeTime-k_Shift_time-2).*x_data(:,2:FieldLifeTime-k_Shift_time-1).*x_data(:,3:FieldLifeTime-k_Shift_time); 
    X = [ones(N_MC,1) x_data(:,1:FieldLifeTime-k_Shift_time) x_data_cube]; 
    y_data_shift(:) = PathTable(:,FieldLifeTime-k_Shift_time+1); 
    coef_shift = regress(y_data_shift,X);
    y_reg_shift(:) = X*coef_shift;
    y_data_continuation(:) = ValueTable(:,FieldLifeTime-k_Shift_time+2);
    coef_continuation = regress(y_data_continuation,X);
    y_reg_continuation(:) = X*coef_continuation;
    ENPVTable_Comparison = [y_reg_shift, y_reg_continuation];
    NPV_SRDM = [y_data_shift, y_data_continuation];
    [ENPV_SRDM,ENPV_SRDM_idx] = max(ENPVTable_Comparison,[],2);
    
    for i_MC = 1: N_MC
        ValueTable(i_MC,FieldLifeTime-k_Shift_time+1) = NPV_SRDM(i_MC,ENPV_SRDM_idx(i_MC));
        if y_reg_continuation(i_MC) > y_reg_shift(i_MC)
            SRDM_DecisionTable(i_MC,FieldLifeTime-k_Shift_time+1) = 0;
        else
            SRDM_DecisionTable(i_MC,FieldLifeTime-k_Shift_time+1) = 1;
        end
    end
end

ShiftValue = PathTable(:,1);
ExpShiftValue = mean(ShiftValue);

ContinuationValue = ValueTable(:,1);
ExpContinuationValue = mean(ContinuationValue);
EVWII = ExpContinuationValue;
VOI = EVWII - EVWOI;
VOI_over_EVWOI_pct = VOI/EVWOI*100;

[~,DWI_Phase1LifeTime_idx] = max(SRDM_DecisionTable,[],2);
DWI_Phase1LifeTime = DWI_Phase1LifeTime_idx-1;

DWI_Phase2LifeTime = zeros(N_MC,1);
for i_MC = 1:N_MC
    Phase1LifeTime_idx_real = DWI_Phase1LifeTime_idx(i_MC,1);
    DWI_Phase2LifeTime(i_MC,1) = Phase2_StopTime_real_Phase1LifeTime(i_MC,Phase1LifeTime_idx_real);
end

DWI_LifeTime = DWI_Phase1LifeTime+DWI_Phase2LifeTime;

% 3. CLRM Approach

N_MC = size(ObsRate_Phase1n2_real_time_ShiftTime,1);
FieldLifeTime = size(ObsRate_Phase1n2_real_time_ShiftTime,2);
N_Phase1n2LifeTime = sum(1:FieldLifeTime+1);
N_LifeTimeComb = N_Phase1n2LifeTime;
Times = 1:1:FieldLifeTime;
CLRM_OptNPV_real = zeros(N_MC,1);
NPV_Tab_matrix = transpose(NPVmatrix_reals);
Prior_ENPV = meanNPVvector(:,3);
[max_Prior_ENPV, max_Prior_ENPV_idx] = max(meanNPVvector(:,3),[],1);
x_data_switch_CLRM = ObsRate_Phase1n2_real_time_ShiftTime(:,:,FieldLifeTime+1);

CLRM_PhaseLifes_Opt_reals = zeros(N_MC,2);

if max_Prior_ENPV_idx <= Times(FieldLifeTime)+1 %Finding if Switch Time is optimal at Y1
    Shift_time = 1;
    t_dataPhase2 = 1;
    while t_dataPhase2 <= Times(FieldLifeTime-Shift_time+1) 
        if t_dataPhase2 == 1 && max_Prior_ENPV_idx == 1 %Switch and Stop at Y1 are optimal
            for i_MC = 1: N_MC
                CLRM_OptNPV_real(i_MC,1) = max_Prior_ENPV; 
            end    
            break; %The whole loop will break here 
        else %Given Switch at Y1 and Stop is not at Y1
            x_data_stop_CLRM = ObsRate_Phase1n2_real_time_ShiftTime(:,:,Shift_time); 
            if t_dataPhase2 == 1 && t_dataPhase2 == 2
                x_data_cube_stop_CLRM = x_data_stop_CLRM(:,1:t_dataPhase2); 
                X_stop_CLRM = [ones(N_MC,1) x_data_stop_CLRM(:,1:t_dataPhase2)]; 
            else
                x_data_cube_stop_CLRM = x_data_stop_CLRM(:,1:t_dataPhase2-2).*x_data_stop_CLRM(:,2:t_dataPhase2-1).*x_data_stop_CLRM(:,3:t_dataPhase2);
                X_stop_CLRM = [ones(N_MC,1) x_data_stop_CLRM(:,1:t_dataPhase2) x_data_cube_stop_CLRM]; 
            end
            y_data_stop_CLRM = NPV_Tab_matrix(:,t_dataPhase2+1:FieldLifeTime+1); 
            y_reg_stop_CLRM = zeros(N_MC,FieldLifeTime-t_dataPhase2+1);
            for t = 1: FieldLifeTime-t_dataPhase2+1
                y_reg_stop_CLRM(:,t) = X_stop_CLRM*regress(y_data_stop_CLRM(:,t),X_stop_CLRM); 
            end
            [StopTime_reg,StopTime_idx] = max(y_reg_stop_CLRM,[],2); 
        for i_MC = 1: N_MC
            if StopTime_reg(i_MC) == y_reg_stop_CLRM(i_MC,1) && CLRM_OptNPV_real(i_MC,1) == 0
                CLRM_OptNPV_real(i_MC,1) = y_data_stop_CLRM(i_MC,1);
                CLRM_PhaseLifes_Opt_reals(i_MC,1) = Shift_time-1; 
                CLRM_PhaseLifes_Opt_reals(i_MC,2) = t_dataPhase2+StopTime_idx(i_MC)-1; 
            else
                continue;
            end 
        end
        end
        t_dataPhase2 = t_dataPhase2+1;
    end   
else
% This part is to find the corresponding optimal stop time given Switch time is not at Y1
    for Shift_time = 2: FieldLifeTime %Finding and recording the optimal switch time before determining the stop time
        N_LifeTimeComb = N_LifeTimeComb-Times(FieldLifeTime-Shift_time+2)-1;
        y_data_switch_CLRM = NPV_Tab_matrix(:,N_Phase1n2LifeTime-N_LifeTimeComb+1:N_Phase1n2LifeTime);
        y_reg_switch_CLRM = zeros(N_MC,N_LifeTimeComb);
        ENPVTabComp = zeros(N_MC,N_LifeTimeComb);
        if Shift_time == 2 && Shift_time == 3
            x_data_cube_switch_CLRM = x_data_switch_CLRM(:,1:Shift_time-1); 
            X_switch_CLRM = [ones(N_MC,1) x_data_switch_CLRM(:,1:Shift_time-1)];
        else
            x_data_cube_switch_CLRM = x_data_switch_CLRM(:,1:Shift_time-3).*x_data_switch_CLRM(:,2:Shift_time-2).*x_data_switch_CLRM(:,3:Shift_time-1); 
            X_switch_CLRM = [ones(N_MC,1) x_data_switch_CLRM(:,1:Shift_time-1) x_data_cube_switch_CLRM]; 
        end
        for i_LifeTimeComb = 1: N_LifeTimeComb 
            coef_reg_CLRM = regress(y_data_switch_CLRM(:,i_LifeTimeComb),X_switch_CLRM);
            y_reg_switch_CLRM(:,i_LifeTimeComb) = X_switch_CLRM*coef_reg_CLRM;
            ENPVTabComp(:,i_LifeTimeComb) = y_reg_switch_CLRM(:,i_LifeTimeComb);
        end
   
    [CLRM_reg,CLRM_idx] = max(ENPVTabComp,[],2);
    
    if Shift_time == FieldLifeTime
        [SwitchDecision_CLRM,SwitchDecision_CLRM_idx] = find(CLRM_idx <= Times(FieldLifeTime-Shift_time+2)+1);
        [ContinueTime_reg,ContinueTime_idx] = find(CLRM_idx == Times(FieldLifeTime-Shift_time+2)+1);
        for i_path = 1: length(ContinueTime_reg) 
            if CLRM_OptNPV_real(ContinueTime_reg(i_path),1) == 0
               CLRM_OptNPV_real(ContinueTime_reg(i_path),1) = y_data_switch_CLRM(ContinueTime_reg(i_path),end);
               CLRM_PhaseLifes_Opt_reals(ContinueTime_reg(i_path),1) = FieldLifeTime; 
               CLRM_PhaseLifes_Opt_reals(ContinueTime_reg(i_path),2) = 0; 
            else
                continue;
            end 
        end
    else
        [SwitchDecision_CLRM,SwitchDecision_CLRM_idx] = find(CLRM_idx <= Times(FieldLifeTime-Shift_time+2)); 
    end
    
    x_data_stop_CLRM = ObsRate_Phase1n2_real_time_ShiftTime(:,:,Shift_time);    
    t_dataPhase2 = 1; 
    while t_dataPhase2 <= Times(FieldLifeTime-Shift_time+1)+1  	
        if t_dataPhase2 == 1 && t_dataPhase2 == 2
            x_data_cube_stop_CLRM = x_data_stop_CLRM(:,1:t_dataPhase2); 
            X_stop_CLRM = [ones(N_MC,1) x_data_stop_CLRM(:,1:t_dataPhase2+Shift_time-2)]; 
        else
            x_data_cube_stop_CLRM = x_data_stop_CLRM(:,1:t_dataPhase2-2).*x_data_stop_CLRM(:,2:t_dataPhase2-1).*x_data_stop_CLRM(:,3:t_dataPhase2);
            X_stop_CLRM = [ones(N_MC,1) x_data_stop_CLRM(:,1:t_dataPhase2+Shift_time-2) x_data_cube_stop_CLRM]; 
        end
        y_data_stop_CLRM = y_data_switch_CLRM(:, t_dataPhase2:Times(FieldLifeTime-Shift_time+1)+1);  
        y_reg_stop_CLRM = zeros(N_MC,Times(FieldLifeTime-Shift_time+1)-t_dataPhase2+2); 
        for t = 1: Times(FieldLifeTime-Shift_time+1)-t_dataPhase2+2 
            y_reg_stop_CLRM(:,t) = X_stop_CLRM*regress(y_data_stop_CLRM(:,t),X_stop_CLRM); 
        end
            [StopTime_reg,StopTime_idx] = max(y_reg_stop_CLRM,[],2); 
        for i_path = 1: length(SwitchDecision_CLRM) 
            if StopTime_reg(SwitchDecision_CLRM(i_path)) == y_reg_stop_CLRM(SwitchDecision_CLRM(i_path),1) && CLRM_OptNPV_real(SwitchDecision_CLRM(i_path),1) == 0
                CLRM_OptNPV_real(SwitchDecision_CLRM(i_path),1) = y_data_stop_CLRM(SwitchDecision_CLRM(i_path),1);
                CLRM_PhaseLifes_Opt_reals(SwitchDecision_CLRM(i_path),1) = Shift_time-1; 
                CLRM_PhaseLifes_Opt_reals(SwitchDecision_CLRM(i_path),2) = t_dataPhase2+StopTime_idx(SwitchDecision_CLRM(i_path))-2; 
            else
                continue;
            end 
        end
            t_dataPhase2 = t_dataPhase2+1;
    end
    end
end

DWI_CLRM_Phase1LifeTime = CLRM_PhaseLifes_Opt_reals(:,1);
DWI_CLRM_Phase2LifeTime = CLRM_PhaseLifes_Opt_reals(:,2);
DWI_CLRM_LifeTime = DWI_CLRM_Phase1LifeTime + DWI_CLRM_Phase2LifeTime;

EVWI_CLRM = mean(CLRM_OptNPV_real);
VOI_CLRM = EVWI_CLRM-EVWOI;
