%% CLRM Approach (Sensitivity Analysis on the Number of Decision Points)
%  This code consists of the modified version of CLRM.m
%  It determines the optimal decision policy by applying different number of decision points as defined. 

N_MC = size(ObsRate_Phase1n2_real_time_ShiftTime_DiffDP,1);
FieldLifeTime = size(ObsRate_Phase1n2_real_time_ShiftTime_DiffDP,2);
NPV_Tab_matrix_DiffDP = transpose(NPVmatrix_reals_DiffDP);
N_Phase1n2LifeTime_DiffDP = size(NPV_Tab_matrix_DiffDP,2);
N_LifeTimeComb_DiffDP = N_Phase1n2LifeTime_DiffDP;
N_Options_DiffDP = fliplr(1:1:N_DecisionPoint+1);
CLRM_OptNPV_real_DiffDP = zeros(N_MC,1);
CLRM_PhaseLifes_Opt_reals_DiffDP = zeros(N_MC,2);
Prior_ENPV_DiffDP = meanNPVvector_DiffDP(:,3);
[max_Prior_ENPV_DiffDP, max_Prior_ENPV_DiffDP_idx] = max(meanNPVvector_DiffDP(:,3),[],1);
x_data_switch_CLRM = ObsRate_Phase1n2_real_time_ShiftTime_DiffDP(:,:,LT_DecisionPoint(N_DecisionPoint+1)+1); 

if max_Prior_ENPV_DiffDP_idx <= N_DecisionPoint+1 
    t_dataPhase2 = 1;
    while t_dataPhase2 <= N_DecisionPoint 
        if t_dataPhase2 == 1 && max_Prior_ENPV_DiffDP_idx == 1 %Switch and Stop at Y1 are optimal
            for i_MC = 1: N_MC
                CLRM_OptNPV_real_DiffDP(i_MC,1) = max_Prior_ENPV_DiffDP; 
            end    
            break; %The whole loop will break here 
        else %Given Switch at Y1 and Stop is not at Y1
            x_data_stop_CLRM = ObsRate_Phase1n2_real_time_ShiftTime_DiffDP(:,:,LT_DecisionPoint(1)+1); 
            X_stop_CLRM = [ones(N_MC,1) x_data_stop_CLRM(:,1:LT_DecisionPoint(t_dataPhase2+1))];  
            y_data_stop_CLRM = NPV_Tab_matrix_DiffDP(:,t_dataPhase2+1:N_DecisionPoint+1); 
            y_reg_stop_CLRM = zeros(N_MC,N_DecisionPoint-t_dataPhase2+1); 
            for t = 1: N_DecisionPoint-t_dataPhase2+1
                coef_reg_stop_CLRM = regress(y_data_stop_CLRM(:,t),X_stop_CLRM);
                y_reg_stop_CLRM(:,t) = X_stop_CLRM*coef_reg_stop_CLRM; 
            end
            [StopTime_reg,StopTime_idx] = max(y_reg_stop_CLRM,[],2); 
        for i_MC = 1: N_MC
            if StopTime_reg(i_MC) == y_reg_stop_CLRM(i_MC,1) && CLRM_OptNPV_real_DiffDP(i_MC,1) == 0
                CLRM_OptNPV_real_DiffDP(i_MC,1) = y_data_stop_CLRM(i_MC,1);
                CLRM_PhaseLifes_Opt_reals_DiffDP(i_MC,1) = 0; 
                CLRM_PhaseLifes_Opt_reals_DiffDP(i_MC,2) = LT_DecisionPoint(t_dataPhase2+StopTime_idx(i_MC)); 
            else
                continue;
            end 
        end
        end
        t_dataPhase2 = t_dataPhase2+1;
    end
else   
    for k_DecisionPoint = 1: N_DecisionPoint-1 
        N_LifeTimeComb_DiffDP = N_LifeTimeComb_DiffDP-N_Options_DiffDP(k_DecisionPoint);
        y_data_switch_CLRM = NPV_Tab_matrix_DiffDP(:,N_Phase1n2LifeTime_DiffDP-N_LifeTimeComb_DiffDP+1:N_Phase1n2LifeTime_DiffDP);
        y_reg_switch_CLRM = zeros(N_MC,N_LifeTimeComb_DiffDP);
        ENPVTabComp = zeros(N_MC,N_LifeTimeComb_DiffDP);
        X_switch_CLRM = [ones(N_MC,1) x_data_switch_CLRM(:,1:LT_DecisionPoint(k_DecisionPoint+1))];
        for i_LifeTimeComb = 1: N_LifeTimeComb_DiffDP 
            coef_reg_CLRM = regress(y_data_switch_CLRM(:,i_LifeTimeComb),X_switch_CLRM);
            y_reg_switch_CLRM(:,i_LifeTimeComb) = X_switch_CLRM*coef_reg_CLRM;
            ENPVTabComp(:,i_LifeTimeComb) = y_reg_switch_CLRM(:,i_LifeTimeComb);
        end
   
    [CLRM_reg,CLRM_idx] = max(ENPVTabComp,[],2);
    
    if k_DecisionPoint == N_DecisionPoint-1 
        [SwitchDecision_CLRM,SwitchDecision_CLRM_idx] = find(CLRM_idx <= N_Options_DiffDP(k_DecisionPoint+1)+1);  
        [ContinueTime_reg,ContinueTime_idx] = find(CLRM_idx == N_Options_DiffDP(k_DecisionPoint+1)+1);
        for i_path = 1: length(ContinueTime_reg) 
            if CLRM_OptNPV_real_DiffDP(ContinueTime_reg(i_path),1) == 0
               CLRM_OptNPV_real_DiffDP(ContinueTime_reg(i_path),1) = y_data_switch_CLRM(ContinueTime_reg(i_path),end);
               CLRM_PhaseLifes_Opt_reals_DiffDP(ContinueTime_reg(i_path),1) = LT_DecisionPoint(N_DecisionPoint+1); 
               CLRM_PhaseLifes_Opt_reals_DiffDP(ContinueTime_reg(i_path),2) = 0; 
            else
                continue;
            end 
        end
    else
        [SwitchDecision_CLRM,SwitchDecision_CLRM_idx] = find(CLRM_idx <= N_Options_DiffDP(k_DecisionPoint+1));  
    end
    
    x_data_stop_CLRM = ObsRate_Phase1n2_real_time_ShiftTime_DiffDP(:,:,LT_DecisionPoint(k_DecisionPoint+1)+1);  
    t_dataPhase2 = 1; 
    while t_dataPhase2 <= N_Options_DiffDP(k_DecisionPoint+1)	
        X_stop_CLRM = [ones(N_MC,1) x_data_stop_CLRM(:,1:LT_DecisionPoint(t_dataPhase2+k_DecisionPoint))]; 
        y_data_stop_CLRM = y_data_switch_CLRM(:, t_dataPhase2:N_Options_DiffDP(k_DecisionPoint+1)); 
        y_reg_stop_CLRM = zeros(N_MC,N_Options_DiffDP(k_DecisionPoint+1)-t_dataPhase2+1); 
        for t = 1: N_Options_DiffDP(k_DecisionPoint+1)-t_dataPhase2+1 
            y_reg_stop_CLRM(:,t) = X_stop_CLRM*regress(y_data_stop_CLRM(:,t),X_stop_CLRM); 
        end
            [StopTime_reg,StopTime_idx] = max(y_reg_stop_CLRM,[],2); 
        for i_path = 1: length(SwitchDecision_CLRM) 
            if StopTime_reg(SwitchDecision_CLRM(i_path)) == y_reg_stop_CLRM(SwitchDecision_CLRM(i_path),1) && CLRM_OptNPV_real_DiffDP(SwitchDecision_CLRM(i_path),1) == 0
                CLRM_OptNPV_real_DiffDP(SwitchDecision_CLRM(i_path),1) = y_data_stop_CLRM(SwitchDecision_CLRM(i_path),1);
                CLRM_PhaseLifes_Opt_reals_DiffDP(SwitchDecision_CLRM(i_path),1) = LT_DecisionPoint(k_DecisionPoint+1); 
                CLRM_PhaseLifes_Opt_reals_DiffDP(SwitchDecision_CLRM(i_path),2) = LT_DecisionPoint(t_dataPhase2+StopTime_idx(SwitchDecision_CLRM(i_path))-1); 
            else
                continue;
            end 
        end
            t_dataPhase2 = t_dataPhase2+1;
    end
    end
end

DWI_CLRM_Phase1LifeTime_DiffDP = CLRM_PhaseLifes_Opt_reals_DiffDP(:,1);
DWI_CLRM_Phase2LifeTime_DiffDP = CLRM_PhaseLifes_Opt_reals_DiffDP(:,2);
DWI_CLRM_LifeTime_DiffDP = DWI_CLRM_Phase1LifeTime_DiffDP + DWI_CLRM_Phase2LifeTime_DiffDP;

EVWI_CLRM_DiffDP = mean(CLRM_OptNPV_real_DiffDP);
VOI_CLRM_DiffDP = EVWI_CLRM_DiffDP-EVWOI_DiffDP;
