%% Determination of DWOI, EVWOI, DWPI, and VOPI (Sensitivity Analysis on the Number of Decision Points)
%  Based on the current number of decision points,
%  this code determines the Decision Without Information and Decision With Perfect Information
%  The corresponding Expected Value Without Information and Value of Perfect Information are estimated

N_Phase1n2LifeTime = size(LifeTime_Table_DiffDP,1);
NPVvector_1real_DiffDP = zeros(N_Phase1n2LifeTime,3);
NPVmatrix_reals_DiffDP = zeros(N_Phase1n2LifeTime,N_MC);
Sum_NPVvector_1real_DiffDP = zeros(N_Phase1n2LifeTime,1);

VWPI_real_DiffDP = zeros(N_MC,1);
DWPI_Phase1LifeTime_real_DiffDP = zeros(N_MC,1);
DWPI_Phase2LifeTime_real_DiffDP = zeros(N_MC,1);

NPVvector_1real_DiffDP(:,1) = LifeTime_Table_DiffDP(:,1);
NPVvector_1real_DiffDP(:,2) = LifeTime_Table_DiffDP(:,2);
meanNPVvector_DiffDP(:,1) = LifeTime_Table_DiffDP(:,1);
meanNPVvector_DiffDP(:,2) = LifeTime_Table_DiffDP(:,2);

for i_MC = 1: N_MC
    for k = 1: N_Phase1n2LifeTime 
        NPVvector_1real_DiffDP(k,3) = NPVtable_LTPhase1_LTPhase2_real(LifeTime_Table_DiffDP(k,1)+1,LifeTime_Table_DiffDP(k,2)+1,i_MC);
        NPVmatrix_reals_DiffDP(k,i_MC) = NPVvector_1real_DiffDP(k,3);
        [VWPI_real_DiffDP(i_MC),DWPI_DiffDP_idx] = max(NPVvector_1real_DiffDP(:,3));
        DWPI_Phase1LifeTime_real_DiffDP(i_MC) = NPVvector_1real_DiffDP(DWPI_DiffDP_idx,1);
        DWPI_Phase2LifeTime_real_DiffDP(i_MC) = NPVvector_1real_DiffDP(DWPI_DiffDP_idx,2);
    end
end

meanNPV_DiffDP = mean(NPVmatrix_reals_DiffDP,2);
meanNPVvector_DiffDP(:,3) = meanNPV_DiffDP(:,1);

[EVWOI_DiffDP,DWOI_DiffDP_idx] = max(meanNPVvector_DiffDP(:,3));
DWOI_DiffDP_Phase1LifeTime = LifeTime_Table_DiffDP(DWOI_DiffDP_idx,1); 
DWOI_DiffDP_Phase2LifeTime = LifeTime_Table_DiffDP(DWOI_DiffDP_idx,2); 
DWOI_DiffDP_LifeTime = DWOI_DiffDP_Phase1LifeTime + DWOI_DiffDP_Phase2LifeTime;
DWPI_LifeTime_real_DiffDP = DWPI_Phase1LifeTime_real_DiffDP + DWPI_Phase2LifeTime_real_DiffDP;
EVWPI_DiffDP = mean(VWPI_real_DiffDP);
VOPI_DiffDP = EVWPI_DiffDP - EVWOI_DiffDP;
