%% Reshaping NPV (Sensitivity Analysis on the Number of Decision Points)
%  This code mainly reshapes the NPV table generated based on the number of decision points
%  The initial NPV table refers to the NPV table that is established by having the decision point per year. 

N_MC = size(ObsRate_Phase1n2_real_time_ShiftTime,1);
FieldLifeTime = size(ObsRate_Phase1n2_real_time_ShiftTime,2);

NPVtable_LTPhase1_LTPhase2_real_DiffDP = zeros(N_DecisionPoint+1,N_DecisionPoint+1,N_MC);
ObsRate_Phase1n2_real_time_ShiftTime_DiffDP = ObsRate_Phase1n2_real_time_ShiftTime;

% NPV for corresponding Decision Points
for i_Option = 1 : N_DecisionPoint+1
    for k_Option = 1 : N_DecisionPoint+1
    NPVtable_LTPhase1_LTPhase2_real_DiffDP(i_Option,k_Option,:) = NPVtable_LTPhase1_LTPhase2_real(LT_DecisionPoint(1,i_Option)+1,LT_DecisionPoint(1,k_Option)+1,:);
    end
end

