%% Calibration of the OU Parameters
%  This section conducts the calibration of the OU parameters used in the OU_Model.m
%  based on the least-squares approach proposed by Smith (2010)
%  This code is originally developed by Smith (2010) and slightly modified for this work 
%  Set of oil price has to be loaded before running this code

d_t = 1; %year 

if (size(OilPrice,2) > size(OilPrice,1))
    OilPrice = OilPrice';
end

% regression is done on the logarithm of oil price
[regression_coefficient,dummy,residual] = regress(log(OilPrice(2:end)),[ones(size(OilPrice(1:end-1))) log(OilPrice(1:end-1))]);

a = regression_coefficient(1);
b = regression_coefficient(2);

theta = -log(b)/d_t;
mu = a/(1-b);
sigma = std(residual)*sqrt((-2*log(b))/(d_t*(1-b^2)));
