%% Calculation of Cashflow and NPV (Economic Uncertainties)
%  This code computes the cashflow and the NPV used in the example problem which economic uncertainties are included
%  This code is the modified version of Section 3 of Modified_LSM_Algorithm.m
%  After running this code, section 4 of Modified LSM Algorithm.m has to be run before proceeding to either CLRM or SRDM. 

FieldLifeTime = size(ObsRate_Phase1n2_real_time_ShiftTime,2);
N_MC = size(ObsRate_Phase1n2_real_time_ShiftTime,1);

% Values of Economic Parameters
Capex_Phase1 = 50; 
Capex_Phase2No1 = 75; 
DisRate = 0.12;  

N_Phase1n2LifeTime = sum(1:FieldLifeTime+1);
CashFlow = zeros(N_MC,FieldLifeTime);
DisCashFlow = zeros(N_MC,FieldLifeTime);
DisCashFlow_ShiftTime = zeros(N_MC,FieldLifeTime,FieldLifeTime+1);
NPV_reals = zeros(N_MC,1);
NPVtable_LTPhase1_LTPhase2_real = zeros(FieldLifeTime+1,FieldLifeTime+1,N_MC);
        
for t = 1: FieldLifeTime
    for time = 1: FieldLifeTime+1
        if t == time 
            if time == 1
                CashFlow(:,t) = OilPrice_Matrix(:,t).*ObsRate_Phase1n2_real_time_ShiftTime(:,t,time) - Opex_Phase2_Matrix(:,t) - Capex_Phase2No1;
                DisCashFlow(:,t) = CashFlow(:,t)/((1+DisRate).^(t)); 
            else
                CashFlow(:,t) = OilPrice_Matrix(:,t).*ObsRate_Phase1n2_real_time_ShiftTime(:,t,time) - Opex_Phase2_Matrix(:,t) - Capex_Phase2After1_Matrix(:,t);
                DisCashFlow(:,t) = CashFlow(:,t)/((1+DisRate).^(t));  
            end
        elseif t < time
            if t == 1
                CashFlow(:,t) = OilPrice_Matrix(:,t).*ObsRate_Phase1n2_real_time_ShiftTime(:,t,time) - Opex_Phase1_Matrix(:,t) - Capex_Phase1;
                DisCashFlow(:,t) = CashFlow(:,t)/((1+DisRate).^(t)); 
            else
                CashFlow(:,t) = OilPrice_Matrix(:,t).*ObsRate_Phase1n2_real_time_ShiftTime(:,t,time) - Opex_Phase1_Matrix(:,t);
                DisCashFlow(:,t) = CashFlow(:,t)/((1+DisRate).^(t)); 
            end
        else
            CashFlow(:,t) = OilPrice_Matrix(:,t).*ObsRate_Phase1n2_real_time_ShiftTime(:,t,time) - Opex_Phase2_Matrix(:,t);
            DisCashFlow(:,t) = CashFlow(:,t)/((1+DisRate).^(t)); 
        end    
        
        DisCashFlow_ShiftTime(:,t,time) = DisCashFlow(:,t);
        
        if time == 1
                NPV_reals(:) = sum(DisCashFlow_ShiftTime(:,1:t,time),2);
                NPVtable_LTPhase1_LTPhase2_real(time,t+1,:) = NPV_reals(:);
        elseif time == FieldLifeTime+1
                NPV_reals(:) = sum(DisCashFlow_ShiftTime(:,1:FieldLifeTime,time),2);
                NPVtable_LTPhase1_LTPhase2_real(time,1,:) = NPV_reals(:);
        else
            if t == time 
                NPV_reals(:) = sum(DisCashFlow_ShiftTime(:,1:time,time),2);
                NPVtable_LTPhase1_LTPhase2_real(time,2,:) = NPV_reals(:);
            elseif t < time
                NPV_reals(:) = sum(DisCashFlow_ShiftTime(:,1:time-1,time),2);
                NPVtable_LTPhase1_LTPhase2_real(time,1,:) = NPV_reals(:);
            else
                NPV_reals(:) = sum(DisCashFlow_ShiftTime(:,1:t,time),2);
                NPVtable_LTPhase1_LTPhase2_real(time,t-time+2,:) = NPV_reals(:);
            end
        end
    end
 end


