%% Cumulative Distribution Functions (CDF) Plot of NPV corresponding to DWOI, DWII (SRDM), and DWPI

N_MC = 100000;
FieldLifeTime = 50;
N_percentile = 99;
N_Phase1n2LifeTime = sum(0:FieldLifeTime+1);

NPV_DWOI = NPVtable_LTPhase1_LTPhase2_real(DWOI_Phase1LifeTime+1,DWOI_Phase2LifeTime+1,:);

NPV_DWII = zeros(N_MC,1);
NPV_DWPI = zeros(N_MC,1);

for i_MC = 1: N_MC
    NPV_DWII(i_MC,1) = NPVtable_LTPhase1_LTPhase2_real(DWI_Phase1LifeTime(i_MC,1)+1,DWI_Phase2LifeTime(i_MC,1)+1,i_MC);
    NPV_DWPI(i_MC,1) = NPVtable_LTPhase1_LTPhase2_real(DWPI_Phase1LifeTime_real(i_MC,1)+1,DWPI_Phase2LifeTime_real(i_MC,1)+1,i_MC);
end

Percentile_DWOI = zeros(N_percentile+2,1);
Percentile_DWII = zeros(N_percentile+2,1);
Percentile_DWPI = zeros(N_percentile+2,1);

for i_percentile = 2: N_percentile+1
    Percentile_DWOI(i_percentile,1) = prctile(NPV_DWOI,i_percentile-1);
    Percentile_DWII(i_percentile,1) = prctile(NPV_DWII,i_percentile-1);
    Percentile_DWPI(i_percentile,1)= prctile(NPV_DWPI,i_percentile-1);
end

Percentile_DWOI(1,1) = Percentile_DWOI(2,1);
Percentile_DWII(1,1) = Percentile_DWII(2,1);
Percentile_DWPI(1,1)= Percentile_DWPI(2,1);

Percentile_DWOI(101,1) = Percentile_DWOI(100,1);
Percentile_DWII(101,1) = Percentile_DWII(100,1);
Percentile_DWPI(101,1)= Percentile_DWPI(100,1);

figure;
y = 0:0.01:1;
cdf_DWOI = plot(Percentile_DWOI,y); hold on;
cdf_DWII = plot(Percentile_DWII,y); hold on;
cdf_DWPI = plot(Percentile_DWPI,y); hold on;

set(cdf_DWOI,'LineWidth',2);
set(cdf_DWII,'LineWidth',2);
set(cdf_DWPI,'LineWidth',2);

set(cdf_DWOI,'Color','blue');
set(cdf_DWII,'Color','red');
set(cdf_DWPI,'Color','green');

legend('DWOI','DWII','DWPI');
xlabel('NPV (million USD)');
ylabel('CDF');

