%% Plot of Different Combinations of Lifetimes of Primary and Secondary Recovery 
%  This code makes the normalized frequency plot of different combinations of lifetimes of primary and secondary recoveries 
%  This code is originally built by Hong et al. (2018).
%  It is slightly modified in this work

% 1. SRDM Approach

Phase1n2LifeTime_Prob = zeros(N_Phase1n2LifeTime,1);
for i_Phase1n2LifeTime = 1:N_Phase1n2LifeTime %% Combinations of LT1 and LT2 
    Counter = 0;
    for i_real = 1:N_MC
        if DWI_Phase1LifeTime(i_real,1) == Phase1n2LifeTimeTable(i_Phase1n2LifeTime,1) && DWI_Phase2LifeTime(i_real,1) == Phase1n2LifeTimeTable(i_Phase1n2LifeTime,2)
            Counter = Counter+1;
        end
    end
    Phase1n2LifeTime_Prob(i_Phase1n2LifeTime,1) = Counter;
end
Phase1n2LifeTime_Prob = Phase1n2LifeTime_Prob/N_MC;

rho_SRDM = corr(DWI_Phase1LifeTime, DWI_Phase2LifeTime);
figure;
scatter(Phase1n2LifeTimeTable(:,1),Phase1n2LifeTimeTable(:,2),[],Phase1n2LifeTime_Prob,'filled','s');
colormap hot
colorbar;
xlabel('Lifetime of Primary Recovery (years)');
ylabel('Lifetime of Secondary Recovery (years)');

% 2. CLRM Approach 

Phase1n2LifeTime_Prob = zeros(N_Phase1n2LifeTime,1);
for i_Phase1n2LifeTime = 1:N_Phase1n2LifeTime %% Combinations of LT1 and LT2 
    Counter = 0;
    for i_real = 1:N_MC
        if DWI_CLRM_Phase1LifeTime(i_real,1) == Phase1n2LifeTimeTable(i_Phase1n2LifeTime,1) && DWI_CLRM_Phase2LifeTime(i_real,1) == Phase1n2LifeTimeTable(i_Phase1n2LifeTime,2)
            Counter = Counter+1;
        end
    end
    Phase1n2LifeTime_Prob(i_Phase1n2LifeTime,1) = Counter;
end
Phase1n2LifeTime_Prob = Phase1n2LifeTime_Prob/N_MC;

rho_CLRM = corr(DWI_CLRM_Phase1LifeTime, DWI_CLRM_Phase2LifeTime);
figure;
scatter(Phase1n2LifeTimeTable(:,1),Phase1n2LifeTimeTable(:,2),[],Phase1n2LifeTime_Prob,'filled','s');
colormap hot
colorbar
xlabel('Lifetime of Primary Recovery (years)');
ylabel('Lifetime of Secondary Recovery (years)');
