%% Mean Oil Rates Plot
%  This code plots the graph of mean oil rates against time (year) for
%  DWOI, SRDM and CLRM

N_MC = 100000;
FieldLifeTime = 50;
N_Phase1n2LifeTime = sum(0:FieldLifeTime+1);
LifeTime = 1:1:FieldLifeTime; 

Mean_ObsRates_DWOI = mean(ObsRate_Phase1n2_real_time_ShiftTime(:,:,DWOI_Phase1LifeTime+1));
Mean_ObsRates_DWOI(:,DWOI_LifeTime+1:FieldLifeTime) = 0;

ObsRates_DWI_SRDM = zeros(N_MC,FieldLifeTime);
ObsRates_DWI_CLRM = zeros(N_MC,FieldLifeTime);

for i_MC = 1: N_MC
  for i_time = 1: FieldLifeTime
    ObsRates_DWI_SRDM(i_MC,i_time) = ObsRate_Phase1n2_real_time_ShiftTime(i_MC,i_time,DWI_Phase1LifeTime(i_MC,1)+1);
    ObsRates_DWI_CLRM(i_MC,i_time) = ObsRate_Phase1n2_real_time_ShiftTime(i_MC,i_time,DWI_CLRM_Phase1LifeTime(i_MC,1)+1);
  end
    ObsRates_DWI_SRDM(i_MC,DWI_LifeTime(i_MC,1)+1:FieldLifeTime) = 0;
    ObsRates_DWI_CLRM(i_MC,DWI_CLRM_LifeTime(i_MC,1)+1:FieldLifeTime) = 0;
end

Mean_ObsRates_DWI_SRDM = mean(ObsRates_DWI_SRDM);
Mean_ObsRates_DWI_CLRM = mean(ObsRates_DWI_CLRM);

figure;
mean_rates_DWOI_plot = plot(LifeTime,Mean_ObsRates_DWOI); hold on;
mean_rates_DWII_SRDM_plot = plot(LifeTime,Mean_ObsRates_DWI_SRDM); hold on;
mean_rates_DWII_CLRM_plot = plot(LifeTime,Mean_ObsRates_DWI_CLRM); hold on;

legend('DWOI','SRDM','CLRM');
set(mean_rates_DWOI_plot,'LineWidth',2);
set(mean_rates_DWII_SRDM_plot,'LineWidth',2);
set(mean_rates_DWII_CLRM_plot,'LineWidth',2);

set(mean_rates_DWOI_plot,'Color','blue');
set(mean_rates_DWII_SRDM_plot,'Color','red');
set(mean_rates_DWII_CLRM_plot,'Color',[0 0.7 0.2]);

legend('DWOI','SRDM','CLRM');
xlabel('Time (years)');
ylabel('Mean OIl Production Rate (million bbl/year)');
