%% Proabilistic Plot of the Oil Price Model
%  This code makes the plots of P10, P50 and P90 of the simulated oil price

N_MC = 100000;
FieldLifeTime = 50;
P10_OilPrice = zeros(1,FieldLifeTime+1);
P50_OilPrice = zeros(1,FieldLifeTime+1);
P90_OilPrice = zeros(1,FieldLifeTime+1);  

LifeTime = 0:1:FieldLifeTime;

for i_LifeTime = 2: FieldLifeTime+1
    P10_OilPrice(:,i_LifeTime) = prctile(OilPrice_Matrix(:,i_LifeTime-1),10);
    P50_OilPrice(:,i_LifeTime) = prctile(OilPrice_Matrix(:,i_LifeTime-1),50);
    P90_OilPrice(:,i_LifeTime) = prctile(OilPrice_Matrix(:,i_LifeTime-1),90);
end

P10_OilPrice(:,1) = OilPrice;
P50_OilPrice(:,1) = OilPrice;
P90_OilPrice(:,1) = OilPrice;
    
figure
P10 = plot(LifeTime,P10_OilPrice); hold on;
P50 = plot(LifeTime,P50_OilPrice); hold on;
P90 = plot(LifeTime,P90_OilPrice); hold on;

set(P10,'LineWidth',2);
set(P50,'LineWidth',2);
set(P90,'LineWidth',2);

legend('P10','P50','P90');
xlabel('Time (years)');
ylabel('Oil Price (USD/bbl)');

