%% Initialization of Input Parameters 
% This code computes the measured oil rates used for the modified LSM algorithm by using the modeled rates from 
% ECLIPSE Reservoir Simulation and initializes the economic parameters. 

% 1. Computation of Measured Oil Production Rates
Rate_Phase1n2_real_time_ShiftTime = Data_Matrix;
ErrorMean4Rate_Pct = 0;
ErrorSD4Rate_Pct = 0.25;
ErrorSD_Matrix = ErrorSD4Rate_Pct.*Rate_Phase1n2_real_time_ShiftTime;
ObsRate_Phase1n2_real_time_ShiftTime = normrnd(Rate_Phase1n2_real_time_ShiftTime,ErrorSD_Matrix);

N_MC = size(ObsRate_Phase1n2_real_time_ShiftTime,1);
FieldLifeTime = size(ObsRate_Phase1n2_real_time_ShiftTime,2);

% 2. Calculation of Cashflow and NPV

% Values of Economic Parameters
OilPrice = 90; 
Capex_Phase1 = 1; 
Capex_Phase2After1 = 1.15; 
Capex_Phase2No1 = 1.15; 
Opex_Phase1 = 1.4; 
Opex_Phase2 = 1.6; 
DisRate = 0.05; 