%% Generation of Different Realization of Permeability
%  This code generates different values of horizontal permeability for top
%  and bottom layers using normal distribution

N_realization = 100;
PermX = zeros(N_realization,2);
PERMX_INIT_a = zeros(2500,1);

mean_PermX_Layer1 = 250;
SD_PermX_Layer1 = 35;
mean_PermX_Layer2 = 178;
SD_PermX_Layer2 = 20;

for i_realization = 1: N_realization 
    filename = ['C:\Users\cuthb\OneDrive - NTNU\2D_LSM_Reservoir_Model\PERMX\PERMX',num2str(i_realization),'.inc'];
    PermX(i_realization,1) = normrnd(mean_PermX_Layer1,SD_PermX_Layer1); 
    PermX(i_realization,2) = normrnd(mean_PermX_Layer2,SD_PermX_Layer2);
    
    PERMX_INIT_a(1:1000,1) = PermX(i_realization,1);
    PERMX_INIT_a(1001:2500,1) = PermX(i_realization,2);
    
    fileID = fopen(filename,'w');
    fprintf(fileID,'%s\n','PERMX');
    fprintf(fileID,'%g\n',PERMX_INIT_a);
    fprintf(fileID,'%s','/');
    fclose(fileID);
end